Unit dberrors;

Interface
Procedure IsamErrorNum(F : Integer);

Implementation
uses wincrt,wingraph,Filer,  Reorg, Rebuild, graphutil2;
Procedure IsamErrorNum(F : Integer);
  {-Display Isam error number and wait for key}

Var
  IsamEMessage,S : string[80];
Begin
  Case F Of
  {  200,9500..10465:
                     Begin
                       fillchar(IsamEMessage,80,0);
                       Str ( F - 9500 : 0, S );
                       IsamEMessage := 'DOS error code <' + S + '> ';
                     End; }
    200   : IsamEMessage := 'Try the program on a slower machine';
    9900 : IsamEMessage := 'Invalid path name';
    9901 : IsamEmessage := 'Too many open files';
    9902 : IsamEMessage := 'Current directory is full';
    9903 : IsamEMessage := 'File not found';
    9904 : IsamEMessage := 'Invalid handle';
    9908 : IsamEMessage := 'Invalid access code';
    10000 : IsamEMessage := 'Page buffer is smaller than MaxHeight';
    10001..10009 : IsamEMessage := 'Serious I/O error occurred while in save mode';
    10010 : IsamEMessage := 'File defect, that can be corrected by rebuild';
    10020 : IsamEMessage := 'Record length less than 22 or more than 2147483647 bytes';
    10030,
    10040 : IsamEMessage := 'Insufficient memory';
    10050 : IsamEMessage := 'Invalid number of keys specified';
    10055, 10125 : IsamEMessage := 'Key too long';
    10060 : IsamEMessage := 'Too many keys, or file read error';
    10065 : IsamEMessage := 'Attempt to write to read only Fileblock';
    10070 : IsamEMessage := 'File read error';
    10075 : IsamEMessage := 'File write error';
    10080 : IsamEMessage := 'Fileblock not open';
    10090, 10100, 10356 :
                          IsamEMessage := 'Insufficient memory to allocate Fileblock';
    10110 : IsamEMessage := 'Drive not ready';
    10120 : IsamEMessage := 'PageSize incompatible with Fileblock';
    10121 : IsamEMessage := 'MaxKeyLen too small';
    10130, 10135 : IsamEMessage := 'Record 0 must not be accessed';
    10140 : IsamEMessage := 'Access not possible, undefined error';
    10150 : IsamEMessage :=
                            'Insufficient handles for flush of network Fileblock';
    10160 : IsamEMessage := 'Fileblock not correctly closed';
    10164 : IsamEMessage := 'Invalid key number';
    10170 : IsamEMessage := 'Consistency of Fileblock endangered';
    10180 : IsamEMessage := 'Attempt to repair Fileblock failed';
    10190 : IsamEMessage := 'Extend handle function requires DOS 3.3 or later';
    10191 : IsamEMessage := 'Insufficient memory for new file handle table';
    10192 : IsamEMessage := 'Unable to initialize new file handle table';
    10200 : IsamEMessage := 'No matching key found';
    10205 : IsamEMessage := 'Data record is currently locked';
    10210 : IsamEMessage := 'No key found and no larger keys available';
    10220 : IsamEMessage := 'Key to delete was not found';
    10230 : IsamEMessage := 'Cannot add duplicate key';
    10240, 10250 : IsamEMessage := 'No larger key found';
    10245, 10260 : IsamEMessage := 'No smaller key found';
    10255, 10265 : IsamEMessage := 'Sequential access not allowed';
    10270 : IsamEMessage := 'No matching key and record number found';
    10280, 10285 : IsamEMessage := 'Index empty';
    10306 : IsamEMessage := 'Too many Fileblock accesses';
    10310 : IsamEMessage := 'Network initialization error';
    10315 : IsamEMessage := 'Network exit error';
    10322, 10323 : IsamEMessage := 'Close of Fileblock not possible '+
                                   'because of a non-removeable lock';
    10330 : IsamEMessage := 'Fileblock lock attempt failed';
    10332 : IsamEMessage := 'Fileblock readlock attempt failed';
    10335 : IsamEMessage := 'Record lock attempt failed';
    10337 : IsamEMessage := 'Record lock attempt failed ' +
                            'because of insufficient memory';
    10340..10342 : IsamEMessage := 'Fileblock unlock attempt failed';
    10345 : IsamEMessage := 'Record unlock attempt failed';
    10355, 10397, 10399 : IsamEMessage := 'A lock prevents the operation';
    10398 : IsamEMessage := 'Fileblock must be locked';
    10410 : IsamEMessage := 'Data file not found';
    10411 : IsamEMessage := 'Insufficient heap space for work buffers';
    10412 : IsamEMessage := 'Record section length exceeds 64K';
    10415 : IsamEMessage := 'Too much records';
    10420, 10425 : IsamEMessage := 'Relative position or scale invalid';
    10430 : IsamEMessage := 'No repair in read only mode';
    10435 : IsamEMessage := 'Tree page greater than 16k';
    10440 : IsamEMessage := 'No creating of dialog file in read only mode';
    10445 : IsamEMessage := 'Invalid Fileblock';
    10446 : IsamEMessage := 'Recursive call of B-Tree Isam';
    10450 : IsamEMessage := 'Initialization already done';
    10455 : IsamEMessage := 'Initialization not yet done';
    10460 : IsamEMessage := 'Reorganization aborted';
    10465 : IsamEMessage := 'Data and save file exist simultaneously';

    Else
      IsamEMessage := '';
  End;

  str(F:5,S);
  S := ' Error # '+S+' '+IsamEmessage;
  fnt0(128,850,maxy*47,1,0,0,50,0,3,'BU',S);
{       S := ' Error # '+S+' Please look up the error in the manual'; }
////  write(S);
// Repeat
// Until keypressed;

End; {  IsamErrorNum }
Begin
 { unit dberrors }
End.
